  org 100h     ; assume ax=bx=0 cx=0xff si=0x100

  jmp S

;  db 0x3f  ; uart

  db 0xc1  ; program change ch2
  db 103   ; star theme
  db 0xc9  ; program change ch10
  db 0x10  ; power kit
  db 0xc0  ; program change ch1
  db 90    ; polysynth

S mov dx,0x330
  lodsw  ; si+=2
;  outsb        ; 3f: uart mode
;  dec dx
  mov cl,6
  rep outsb

P mov al,0x90
  lea si,[bx+NOTES-1]
  call PLAY

  push bx
  and bx,0xf
  mov al,0x99
  lea si,[bx+DRUMS-1]
  call PLAY
  pop bx

  push bx
  shr bx,1
  jc NM
  shr bx,1
  jc NM
  mov al,0x91
  lea si,[bx+MELODY-1]
  call PLAY
NM:
  pop bx

  inc bx
  and bx,0x3f

  hlt
  hlt
  hlt

  in al,0x60
  dec al
  jnz P

  ret

PLAY:
  out dx,al
  outsb
  mov al,0
  out dx,al
  cmpsb
  jz N
  dec si
  outsb
  mov al,0x7f
  out dx,al
N ret


%define C 48
%define D 50
%define S 51
%define E 52
%define F 53
%define G 55
%define A 57
%define B 58
%define H 59
%define c 48+12
%define d 50+12
%define s 51+12
%define e 52+12
%define f 53+12
%define g 55+12
%define a 57+12
%define b 58+12
%define h 59+12
%define c_ 48+24
%define d_ 50+24
%define _ 0

db A
NOTES:
db d,E,G,H,c,d, c,H,G,E, d,E,G,H,c,d,
db d,S,G,B,c,d, c,B,G,S, d,S,G,B,c,d,
db c,D,F,A,B,c, B,A,F,D, c,D,F,A,B,c,
db A,C,D,F,G,A, G,F,D,C, A,C,D,F,G,A,

;db 4,0,1,2,3,4, 3,2,1,0, 4,0,1,2,3,4,
;db E,G,H,c,d,
;db S,G,B,c,d,
;db D,F,A,B,c,
;db C,D,F,G,A,

db f,
MELODY:
db h,_,_,c_, d_,_,_,b, a,_,_,g, c,f,_,_,

DRUMS:

%define B 36, ; bass drum 1
%define S 40, ; electric snare
%define H 44, ; pedal hi-hat
%define O 46, ; open hi-hat

db B H O H  S H O B  H B B H  S H O S
